\documentclass[english]{article}

\usepackage{babel}
\usepackage{graphicx}
\usepackage{alltt}
\usepackage{url}
%\usepackage{ngerman}
\usepackage{color}
\usepackage{framed}
\usepackage{todonotes}
\usepackage{listings}
\usepackage{xcolor}
\usepackage{tikz}
\usepackage{hyperref}


\lstset{
  basicstyle=\ttfamily,
  columns=fullflexible,
  frame=single,
  breaklines=true,
  postbreak=\mbox{\textcolor{black}{$\hookrightarrow$}\space},
  escapeinside=||,
}


\hypersetup{
    colorlinks=true,
    linkcolor=blue,
    filecolor=magenta,      
    urlcolor=cyan,
    pdftitle={Overleaf Example},
    pdfpagemode=FullScreen,
    }
    
\newcommand{\shrug}[1][]{%
\begin{tikzpicture}[baseline,x=0.8\ht\strutbox,y=0.8\ht\strutbox,line width=0.125ex,#1]
\def\arm{(-2.5,0.95) to (-2,0.95) (-1.9,1) to (-1.5,0) (-1.35,0) to (-0.8,0)};
\draw \arm;
\draw[xscale=-1] \arm;
\def\headpart{(0.6,0) arc[start angle=-40, end angle=40,x radius=0.6,y radius=0.8]};
\draw \headpart;
\draw[xscale=-1] \headpart;
\def\eye{(-0.075,0.15) .. controls (0.02,0) .. (0.075,-0.15)};
\draw[shift={(-0.3,0.8)}] \eye;
\draw[shift={(0,0.85)}] \eye;
% draw mouth
\draw (-0.1,0.2) to [out=15,in=-100] (0.4,0.95); 
\end{tikzpicture}}


\title{Lab Journal for Applied Security Lab}
\author{Luzian Bieri}
\date{\today}


\begin{document}
\maketitle

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{framed}
\noindent
{\it
This lab journal documents your work with the book. Here are some writing guidelines:
\begin{itemize}
\item We do not require that you solve all problems and questions, but do aim for about 75\% completeness.

\item The problem and questions of the extension chapter about computer forensics are optional. 

\item Adhere to the template below. If you prefer, you can write the lab journal using a different tool (e.g., mark-down, Word), but make sure that every problem and question is numbered as in the book.

\item Provide brief and concise answers.

\item Use a spell checker before hand-in!

\end{itemize}
}
\end{framed}

\section*{Chapter 1}

\paragraph{Problem 1.1}
Can you name other examples where the failure to separate data and code leads to security problems?

Regex vulnerabilities (ReDoS)

\paragraph{Problem 1.2}
Extend some of the examples in Example 1.9 to illustrate the problem of transitive trust.

\begin{itemize}
    \item Parents tell their children not to take candies from strangers. But let them have candies from their neighbours, assuming no bad intentions from them.
    \item Countries do not just trust individuals at their borders but base their trust on evidence which is hard to forge, like passports. These countries rely on the country of origin to only hand out the passports to the correct individuals. The country of origin relies on the manufacturer to make the passports hard to forge.
    \item Airlines and airports do not trust passengers’ luggage but have it screened. The airports need to trust their personal to check the scans correctly and not let any dangerous luggage pass through.
\end{itemize}


\paragraph{Problem 1.3}
Many of the principles discussed are not independent from the other principles. Some of them overlap, while others are in conflict. Identify at least three cases in which two or more principles overlap or are in conflict. Explain the reasons for this.


\begin{itemize}
    \item Minimum Exposure and Least Privilege generally go in the same direction, thus will have some overlap.
    \item Single point of failure vs. Simplicity. Having redundancy makes the system usually more complex. Same goes with the usability
    \item Usability vs. Least Privilege, there will be tradeoffs.
\end{itemize}

\paragraph{Question 1.1}
Explain the principle of secure, fail-safe defaults using firewalls as an example.

Using a whitelist approach, every rule needs to be specified individually and added intentionally. The default behaviour is to block the traffic which is the secure approach.

\paragraph{Question 1.2}
Explain the principle of least privilege and provide two applications of this principle in your daily life.

Only give the least privilege to a subject in order to fulfill its task. Give the teaching assistant only a key which enables him/her to access the rooms of the respective lab and not all rooms belonging to the department building. Only share the folder on polybox with the group needed for the project instead of the complete polybox folder with all my study documents.

\paragraph{Question 1.3}
Explain why security by obscurity typically does not lead to an increased level of security.

The "{}hard, mathematical"{} security of a system does not depend on the implementation of a certain algorithm but only on the algorithm itself and a good key-selection, given the implementation is correct. 

\paragraph{Question 1.4} In the terminology of Saltzer and Schroeder [29], complete mediation describes the security principle which requires access checks for any object each time a subject requests access. Explain why this principle may be difficult to implement and give examples that illustrate the difficulties you mention.

Access checks take time especially when done for every object for every access. Furthermore access rights have to be determined for each object and the rights given by someone.

\paragraph{Question 1.5}
In contrast to the open design principle, the minimum exposure principle demands that the information given away is reduced to a minimum. Are these principles contradictory? Provide examples that support your answer.

No, first and foremost the open design principle states, that the security should not depend on keeping the architecture closed.
The security is not compromised when disclosing the used tools as to Kerkoff's principle the security only depends on keeping the keys secret.

\paragraph{Question 1.6}
Explain the principle of compartmentalization and give an example.

Keep different resources in different compartments: if one is compromised, the others are still save. Example: Containerized Micro-services (Docker, Kubernetes)

\paragraph{Question 1.7}
Give examples of systems that are trustworthy and trusted, systems that are trusted but not trustworthy, and systems that are trustworthy but not trusted.

\begin{itemize}
    \item Bridge over a river
    \item Thin, cracked, slippery wooden plank over a creek
    \item Thin but strong rope, to swing over the river
\end{itemize}

\paragraph{Question 1.8}
What is a whitelist approach and how does it differ from a blacklist approach? Give examples of when one approach is preferable to the other.

Whitelist: permission \emph{denied} unless specified differently, blacklist:  permission \emph{granted} unless specified differently. 
Firewalls: whitelist, skipped files by the antivirus scanner: blacklist. 

\paragraph{Question 1.9} A company wants to provide a service to their customers over the Internet. Figure 1.1 shows two different system design solutions.

Solution a: The server providing the service is located in a demilitarized zone (DMZ) that is separated from the Internet and the intranet, controlled by a firewall.

Solution b: The server providing the service is located in the intranet that is separated from the Internet, controlled by a firewall.

Compare the two designs and give at least four arguments for or against them. Use the security principles to substantiate your arguments. Which of these designs would you prefer?

\begin{itemize}
    \item Separating the server from the Intranet fulfills the compartmentalization, separating the server from the intranet. The intranet is more vulnerable since the employees machines might be target for various attacks, e.g. phishing.
    \item Configuring the firewall for option A will be more complex.
    \item In solution A, Minimum Exposure is easier implemented, as we can configure different rules for communication between internet, server and intranet. 
    \item Solution creates more traffic through the firewall, which might need a more expensive firewall.
\end{itemize}

Preferred solution: A




\section*{Chapter 3}

\paragraph{Problem 3.1}
How do the outputs of tcpdump differ if you try to connect to an open TCP port compared to a closed TCP port?

Open:
\begin{lstlisting}
IP Alice.ssh > mallet.34622: Flags |\textcolor{red}{[S.]}|, seq 1723560150, ack 2704065927, win 28960, options [mss 1460,sackOK,TS val 173315 ecr 197151,nop,wscale 6], length 0
\end{lstlisting}
Closed:
\begin{lstlisting}
IP Alice.24 > mallet.57628: Flags |\textcolor{red}{[R.]}|, seq 0, ack 52202993, win 0, length 0
\end{lstlisting}
For port 24 Alice responds with the TCP RESET flag set. Otherwise TCP SYN is set.

\paragraph{Problem 3.2}
What is the difference between a stealth scan and a normal scan?

It sends invalid flags preventing the establishment of a TCP connection.

\paragraph{Problem 3.3}
The option -sI starts what is called an idle scan. This scan method allows an adversary to scan a host without sending packets from his real IP address. Explain how this works.

Zombie and a side channel attack thereof, [skipped question]

\paragraph{Problem 3.4} 
Why is there no stealth mode for UDP scans?

No connection established in the first place. Thus no handshakes are performed on which one could use a set of inhibited flags. 

\paragraph{Problem 3.5}
Why may stealth scans attract more attention than simple connect scans? Why are they then called stealth scans? From this perspective, what is the advantage of a SYN scan compared to other stealth scan methods?

There is an invalid set of flags sent inbetween the subjects which can be detected by another subject. They are calles stealth scans, since the do not initiate a TCP session with the host. SYN scans look  for an external supervising subject, like a firewall, as "{}normal"{} initiations of TCP sessions.

\paragraph{Problem 3.6}
Use Nmap to gather more information about the HTTP server running
on Alice. Which options for Nmap did you choose and why? What information did you receive about the server?

Command: \verb+nmap -O -sV -v Alice -p 80+ as explained on page 33. Information about the operating system and the service version might be useful. 
Retrieved information in red:
\begin{lstlisting}
PORT   STATE SERVICE VERSION
80/tcp open  http    |\textcolor{red}{Apache httpd 2.4.18 ((Ubuntu))}|
MAC Address: 08:00:27:ED:5B:F5 (Oracle VirtualBox virtual NIC)
Warning: OSScan results may be unreliable because we could not find at least 1 open and 1 closed port
Device type: general purpose
Running: Linux 3.X 4.X
OS CPE: cpe:/o:linux:linux_kernel:3 cpe:/o:linux:linux_kernel:4
OS details: |\textcolor{red}{Linux 3.2 - 4.0}|
Uptime guess: 0.034 days (since Mon Oct  4 14:08:12 2021)
Network Distance: 1 hop
TCP Sequence Prediction: Difficulty=261 (Good luck!)
IP ID Sequence Generation: All zeros

\end{lstlisting}

\paragraph{Problem 3.7}
What are the main differences between the scan using Nmap and the scan using OpenVAS?

OpenVAS uses various tools including Nmap and tries to analyze/try a list of known vulnerabilities.

\paragraph{Problem 3.8}
Use the Netcat tool or Telnet to connect to port 12345 on bob. What kind of service appears to be running on this port? What might be a potential vulnerability in such a service? Can you gather any evidence that might confirm your suspicion of a potential vulnerability?

Running an echo server. Issues: Buffer overflow, String format attack. Keeps string somewhere in memory. Example enter \verb+0xXx+, press enter receive \verb+You said: 0xXx+, press enter again, receive: \verb+You said: \nxXx+

\paragraph{Problem 3.9}On bob, randomly choose three processes and provide the following information: installed version, task/purpose, configuration files, open ports, user name of the owner.

\begin{itemize}
    \item cron: 
    \begin{itemize}
        \item Version 3.0pl1-128+b1 
        \item Task: Process scheduling daemon
        \item Ports: none
        \item Config files: /etc/cron/cron.d
        \item User: root, bob
    \end{itemize}
    \item mysql-server: 
    \begin{itemize}
        \item Version 1.0.2
        \item Task: MySQL database Server binaries and system d...
        \item Ports: localhost:mysql
        \item Config files: /etc/mysql/mysql.d
        \item User: mysql
    \end{itemize}
    \item Apache2: 
    \begin{itemize}
        \item Version 3.0pl1-128+b1 
        \item Task: Apache https Sserver
        \item Ports: www=80/tcp
        \item Config files: /etc/apache2/apache2.d
        \item User: root, www-data
    \end{itemize}
\end{itemize}

\paragraph{Problem 3.10} Explain the concept of runlevels and the role of the scripts in /etc/rcX.d/.

As of \href{https://en.wikipedia.org/wiki/Runlevel}{Wikipedia}: 
A runlevel is a mode of operation in the computer operating systems. There exist 7 different levels. A runlevel defines the state of the machine after boot. Different runlevels are typically assigned (not necessarily in any particular order) to the single-user mode, multi-user mode without network services started, multi-user mode with network services started, system shutdown, and system reboot system states. In standard practice, when a computer enters runlevel zero, it halts, and when it enters runlevel six, it reboots. The intermediate runlevels (1–5) differ in terms of which drives are mounted and which network services are started. Default runlevels are typically 3, 4, or 5.

\paragraph{Problem 3.11}
A Telnet daemon (telnetd) is running on Alice. Find out how this service is started. Which commands did you use? Describe two ways to stop the service without removing any software packages. Uninstall the package telnetd. properly.

\begin{itemize}
    \item using lsof, telnetd ist started by xinetd.
    \item stopping via systemctl is no option, i assume that xinetd has the same option somhow. Remove the symlink in /etc/xinetd.d/telnet should do the trick aswell, after a restart.
    \item \verb+apt-get remove telnetd+
\end{itemize}

\paragraph{Problem 3.12}
List advantages and disadvantages of the protection mechanisms described in this section: firewall, TCP wrapper and configuration.

\begin{itemize}
    \item Firewall: Kernel level, one central configuration for the entire system, only on IP level
    \item TCP wrapper: Deeper package inspection, needs inetd
    \item specific configuration for every service/application. Must be done correctly in every service, prone fot errors.
\end{itemize}


\paragraph{Problem 3.13}
How could you configure iptables so that the port scan would indicate that the port is closed?

Reject instead of droping

\paragraph{Problem 3.14}
The firewall example implements a blacklist approach to access control: All undesirable connections are explicitly prohibited and everything else is allowed by default. The opposite approach is the whitelist approach, where authorized connections are explicitly permitted and everything else is prohibited by default. Compare these two approaches.

Whitelisting every needed connection explicitly is more secure but also more tedious to maintain.

\paragraph{Problem 3.15}
Explain why Nmap shows the port as being open but it is not possible to establish a connection using an FTP client.

The TCP connection is initiated correctly, the wrapper rejects the connection afterwards by inspecting the packages.

\paragraph{Problem 3.16}
In both configurations, iptables as well as TCP wrapper, we have used symbolic host names such as “Alice” or “bob” instead of numerical IP addresses. Identify a security problem that arises when symbolic names are used.

mallet could "{}impersonate"{} bob or Alice using known DNS issues.

\paragraph{Problem 3.17} 
In this question, we put all the previous parts together. How can Alice be configured to enforce the policy given below? Choose appropriate methods to implement this policy. Do not forget to test whether your measures are effective.

[Skipped question]


\paragraph{Question 3.1}
What is meant by system hardening? Under what circumstances does system hardening makes sense?

Usually via a tool: apply a set of rules and configuration in various spaces. E.g. permissions on files, firewall configurations, etc. In order to minimize the surface for an attack. Generally it makes always sense to harden a system. It is especially recommended for systems accessible from the internet.

\paragraph{Question 3.2}
Does system hardening make sense even for systems that are protected by a firewall? Explain your answer.

As already mentioned, it still makes sense. For example the firewall might have some misconfigurations. Nevertheless a firewall is indispensable in order to guarantee safety in the network.

\paragraph{Question 3.3}
Give two examples of how a service provided by a Linux server to the network could be restricted in cases where the services must not be turned off.

Firewall, use of a TCP wrapper. Both restrict incoming packets and are filtered out by some predefined rules. A more sophisticated approach using deep package inspecting would be even better. 

\paragraph{Question 3.4}
You have used the port scanner Nmap to identify running network services on a server. Now suppose that you have placed your server behind a firewall, and have used Nmap to find potentially forgotten open ports. Nmap’s output shows many open UDP ports. What could be the problem?

The firewall probably just drops the packets, for UDP sending the packets to a black hole is indistinguishable form an open port since no session sis established.

\paragraph{Question 3.5}
Explain the differences between a stealth scan and an ordinary port scan.

Same as in Problem 3.2. For a stealth scan we send an incompatible combination of flags such that no TCP session is established. While in an ordinary scan we let a TCP session to be established.

\paragraph{Question 3.6}
Using the command option nmap -O [IP-Addr], Nmap can sometimes determine the target computer’s operating system. Explain the underlying principle. Why is this a possible security problem and how can you prevent it?

Nmap sends dozens of UDP and TCP packets, analyzes the responses and compares it to a database of know OS fingerprints. This violates the principle of Minimum Exposure as it gives out more information than needed. If for that very OS an exploit is known, the attacker can employ this. Solution: employ some kernel patches, obfuscating by randomizing the response, Ignore "{}bogus packets"{} with random flags, drop the packets with some set flags, known to be employed by nmap.

\section*{Chapter 4}

\paragraph{Problem 4.1}
Is it possible to increase security by using an authentication mechanism
based on the MAC (Ethernet) address instead of the IP address? What is a
fundamental argument against authentication based on MAC addresses in most
network settings?

Spoofing a MAC address is not more difficult than spoofing an IP address.


\paragraph{Problem 4.2}
What are the individual steps involved in establishing an SSH connection?

Connect to the server,  agree on protocol and software version (similar to OpenSSL), Verify the host, authenticate via password, communicate via shell.

\paragraph{Problem 4.3}
With regard to the steps you gave in your answer to Problem 4.2, what are the differences between authentication based on public keys and password-based authentication?

Instead of authenticating the user via password, the server verifies the authenticity via by challenging the clients private key.

\paragraph{Problem 4.4}
How is bob’s SSH daemon able to verify that Alice possesses the correct private key without sending the key over the network?

The server sends a random message encrypted using the public key of the client. Only a client with the correct private key can decrypt it.

\paragraph{Problem 4.5}
What are the security-relevant advantages of authentication using public key cryptography compared to the IP address-based authentication of rsh? What is the main threat that still remains?

Since the asymetric method is assumed to be cryptographically safe, impersonating another person is impossible. Remaining problem: Stealing of the private and public key from the client.


\paragraph{Problem 4.6}
The meaning of the basic access rights, read (r), write (w) and execute (x), is obvious for conventional files. What is their meaning for directories? Find the answers through experimentation!

\begin{itemize}
    \item r: list the files, but cant access them
    \item w: write to the directory, but cannot list or enter
    \item x: can access the files (cd) in the directory but cannot list
\end{itemize}

\paragraph{Problem 4.7}
Use the command above to find all world writable files on Alice. Also, find all world readable files in /etc and /var/log. Which files or directories might not be configured properly? Which permissions could be more restrictive?

[skipped question]

\paragraph{Problem 4.8}
How is the default file permission computed from the creating program’s default permission and the user-defined umask value?

bitwise: \verb+default AND NOT umask+

\paragraph{Problem 4.9} Determine the default umask value, which is set in /etc/profile on Alice. Why is this a good default?

\verb+umask 022+ Owner has read and write permissions the parent group only has read permissions. Which is a reasonable default setup

\paragraph{Problem 4.10}
In which file could you (as an ordinary system user) alter your own default umask? Hint: The invocation order is described in the manual page of bash.

In the rc-File of the respective shell, e.g. .bashrc, .zshrc

\paragraph{Problem 4.11}
Read the manual page of chattr and determine which file attributes could be used to increase security in special situations. Provide an example where it would make sense to use each of these attributes.

According to \href{https://man7.org/linux/man-pages/man1/chattr.1.html}{man7.org}
\begin{itemize}
    \item d: A file with the 'd' attribute set is not a candidate for backup when the dump(8) program is run.
    \item a: A file with the 'a' attribute set can only be opened in append mode for writing. 
    \item i: A file with the 'i' attribute cannot be modified: it cannot be deleted or renamed, no link can be created to this file, most of the file's metadata can not be modified, and the file can not be opened in write mode.
    \item s: When a file with the 's' attribute set is deleted, its blocks are zeroed and written back to the disk.  
\end{itemize}

\paragraph{Problem 4.12}
Why is not even root allowed to execute a file if the execute bit is not set, although root has all permissions by definition? How is this related to the environment variable PATH, and why should “.” not be added to the path?

The execute-bit is used for the permission AND make a file executable, thus sudo can't execute it either. Including "{}."{} might enable one to execute a program by accident.

\paragraph{Problem 4.13}
Following up on the last problem, note that some people append “.” as the last entry in the path and argue that only the first appearance of the executable file is used when typing a command. Is this variant also prone to potential security problems? If so, what are these problems?

If a user misspells a command and there exists an executable with said name it will run without explicitly making it executable. 

\paragraph{Problem 4.14}
In what respect does the passwd command improve a system’s security? How could an ordinary user be given the ability to change his own password without a setuid program?

Separate passwordfile for each user. Without setuid it would be impossible to alter the passwd file for a normal user.

\paragraph{Problem 4.15}
Search for four setuid programs on Alice and explain why they are setuid.
\begin{itemize}
    \item su: allows the user to run sudo commands
    \item passwd: edits a write protected file
    \item \dots
\end{itemize}

\paragraph{Problem 4.16}
Find some setgid programs on Alice and explain why they are setgid. Could the setuid programs in the last problem be setgid instead of setuid?

According to solution: \verb+/usr/bin/wall+ Message to all (writing on /dev/?ty*). By adjusting the permissions on \verb+passwd+ to setuid one needs to adjust the permissions on the passwd-file. 

\paragraph{Problem 4.17}
The script fragment is still prone to a race condition. Explain what a race condition is and how this may affect this script’s behavior when run as root.

If the file is deleted and the symlink created between check for the symlink and the interaction with the file. The same issue still is the same.

\paragraph{Problem 4.18} Read the manual page of touch. What is this command primarily used for?

Update the last modified time.

\paragraph{Problem 4.19}
Use mktemp to prevent the symbolic-link attack in Sect. 4.4.1. Implement what you have learned so far to create the temporary file. Is this script now secure against the symbolic-link attack? What can the adversary still do?

If the filename can be guessed, the attack still holds. Need enough random names.

\paragraph{Problem 4.20}
Why should you prefer full paths over relative paths? Explain what an adversary could do when using relative paths.

If one moves the script to a different location, all relative paths point to different files.

\paragraph{Problem 4.21}
Read the manual pages of edquota and setquota. What kinds of limits can you set? What is the difference between a soft limit and a hard limit?

You can set limits of the storage blocks per user.
As per \href{https://linux.die.net/man/8/edquota}{linux.die.net} Users are permitted to exceed their soft limits for a grace period that may be specified per filesystem. Once the grace period has expired, the soft limit is enforced as a hard limit.  Hard limit directly prevents the operation in question

\paragraph{Problem 4.22}
Which resources are exhausted in this attack? Why is the user’s quota not debited when the links are created? What can the adversary accomplish with such an attack? How can this problem be solved?

The file resp. the directory is owned by the superuser which has no quota while still world writable. Move the directory to a separate partition. 

\paragraph{Problem 4.23}
What are the security-relevant advantages of chroot environments, for example, for a server program?

Damage is contained to the jail-directory.

\paragraph{Problem 4.24}
What problem arises when building sophisticated chroot environments? What difficulties do you expect in terms of the administration and the operation of such environments?

Maintenance is going to be a nightmare. As every chroot environment has to be maintained.


\paragraph{Question 4.1}
It is mentioned at the start of this chapter that access control is used in memory management, operating systems, middleware application servers, databases and applications. In each of these cases, what are the respective subjects and objects (i.e., resources)? What kinds of authorization policies are typically enforced by the access control mechanism?

\todo{todo}

\paragraph{Question 4.2} 
Explain what chroot does and what kinds of security problems can be tackled using this command.

Similar to a virtual environment, changing the root directory to the passed directory for the current process. Prevents the program from accessing files outside this directory known as jail.

\paragraph{Question 4.3}
Give two examples of how the application of chroot is helpful and explain the benefits.

Setting up or fixing an existing Linux system. chroot from another system into the broken system, e.g. while setting up arch. Running an application in a separated environment which would be too risky to run on the usual system, e.g. for testing.

\paragraph{Question 4.4}
Unfortunately, chroot has some security weaknesses. Explain two of these.

chroot is not doing complete containerization, e.g. if one mounts the /proc into the chroot directory, a chroot process can see all other running processes.

If a chroot program is running with root privileges, it might be able to create a second chroot environment and thus breaking out of the first. Needs e.g. a Perl interpreter or a C-compiler. Fix: setuid to a nonzero value directly after chrooting.

\paragraph{Question 4.5}
You have learned about file attributes such as r, w, x and t. Briefly explain these attributes.

\begin{itemize}
    \item r: read the file
    \item w: modify the file
    \item x: execute the file
    \item t: sticky bit set retain file in memory, for dir: prevents everyone but the owner from renaming, moving, or deleting the file.
\end{itemize}

\paragraph{Question 4.6}
There are file additional attributes beyond those of the last question. Name two such attributes and a security application for each of them.

\begin{itemize}
    \item s: secure delete the file, by setting its blocks to 0
    \item i: makes the file immutable. Can't move, edit, delete this file and even can't create links to it unless root. 
\end{itemize}

\paragraph{Question 4.7} 
Explain the concept behind the setuid (and setgid) bits of Unix files.

Allows the user to execute a program with the file's owner's permissions. E.g. a program editing the file /etc/passwd. setuid set permissions to the users right, setgid sets it to to owners groups.

\paragraph{Question 4.8}
Explain why a buffer-overflow vulnerability in an executable program where the setuid bit is set is typically more serious than a similar vulnerability where the setuid bit is not set.

If the setuid bit is set, the program is executable as root even though started by a normal user. The root user has no quota by definition, thus it can brick the entire system.

\paragraph{Question 4.9}
Recently there have been various attacks based on so-called DNSrebinding. A description of such an attack is given below. The setting is depicted in Fig. 4.1.

1. Explain how the adversary can use the technique described in the attack to access a server behind the firewall. That is, describe the chain of events that leads to information being transmitted from the internal (possibly secret) server to the adversary.

If the attacker's DNS server responds with the IP address of the internal server in the intranet, lets the client read data and then for the next request returns again its own IP address, the victim might possibly leak data from the internal server to the attacker.

2. Describe two countermeasures that could prevent such an attack. These countermeasures should not be overly restrictive. For example, closing the firewall for all connections to the Internet would not be an option.

\begin{itemize}
    \item Requiring SSL, and certificates for all connections.
    \item DNS Pinning on the installed browser. 
\end{itemize}




\section*{Chapter 5}
\paragraph{Problem 5.1}
Why is rsyslogd not used by all server programs for logging? In particular, when should rsyslogd be avoided?

Large log output e.g. a database might overwhelm/block syslogd.
\paragraph{Problem 5.2}
Describe the logging procedure of rsyslogd as it is observed above and by reading the manual page of rsyslogd(8).

According to \href{https://man7.org/linux/man-pages/man8/rsyslogd.8.html}{man7.org} rsyslog reads from the socket under /dev/log. The log is then saved to the configured files. 

\paragraph{Problem 5.3} On bob, find the log files for the network services httpd and sshd. Briefly explain the logging mechanisms and why they are applied.

\verb+grep log /etc/apache2/apache2.conf+, leads to \verb+${APACHE_LOG_DIR}/error.log+, with \verb+APACHE_LOG_DIR+ being \verb+/var/log/apache2+. sshd uses syslog per default. 

\paragraph{Problem 5.4} 
On bob, find out what the file /var/log/mysql/mysql.log is used for. Which programs use them? Configure MySQL so that its log information is stored in /var/log/mysql.log.

\verb+/var/log/mysql/mysql.log+ does not exist. but \verb+/var/log/mysql/error.log+ which is written by the mysql server directly. This behaviour can be modified in the file \verb+/etc/mysql/my.cnf+.

\paragraph{Problem 5.5}
How can you configure Alice and bob so that all of bob’s messages are logged by Alice?

Accoding to \href{https://www.rsyslog.com/sending-messages-to-a-remote-syslog-server/}{www.rsyslog.com}: add the first line as follows:

\verb+*.* action(type="omfwd" target="Alice" port="10514" protocol="tcp")+ in \verb+/etc/rsyslog.conf+ on bob.

\paragraph{Problem 5.6}
What are the pros and cons of this method with respect to security?

All logs can be collected/analyzed on a dedicated system. Interception by a third party might be problematic. 

\paragraph{Problem 5.7}
Why is this security relevant?

Question unclear. Which security?

\paragraph{Problem 5.8}
What can an adversary gain by using such a program to modify specific entries in log files?

Hiding his actions on the system.

\paragraph{Problem 5.9}
Why may altered entries be more dangerous than deleted ones?

Altered entries are harder to detect than missing ones.

\paragraph{Problem 5.10}
How would you design a system that makes it as difficult as possible for an adversary to compromise log information? Be creative in your solution!

Similar to a blockchain. Hashing new entries with the hash of the previous ones. 

\paragraph{Problem 5.11}
How is logrotate usually started?

According to \href{https://linux.die.net/man/8/logrotate}{linux.die.net} Normally, logrotate is run as a daily cron job.

\paragraph{Problem 5.12}
Search for entries that indicate login failures. What files do you have to check for this?

The file \verb+/var/log/auth.log+

\paragraph{Problem 5.13}
Configure Swatch so that it shows all log entries indicating that a user switches to superuser mode and back. Color the switch to superuser mode red and color the switch back green. In addition, color all entries indicating the use of the sudo command blue. What does your Swatch configuration file contain?


\begin{lstlisting}
watchfor /session opened for user root/
echo red
watchfor /session closed for user root/
echo green
watchfor /sudo/
echo blue
\end{lstlisting}

\paragraph{Problem 5.14}
What are the disadvantages of working with checksums? What is checked? What cannot be checked?

Does only check the file content. Furthermore It might be possible to adjust the old checksum in a way that it looks like the old state is the correct one even though it has been tampered with.

\paragraph{Problem 5.15}
Why should you store the reference database on read-only media such as a CD when using AIDE on a running system?

as already mentionned in 5.14, an adversary might be able to tamper with the database, assuming he has the right permissions. Thus he will be able to change programs and then create a new database such that it looks ok for the operator.

\paragraph{Problem 5.16}
Create a new file /etc/evilScript.sh, then change the owner of an existing file in /etc such as /etc/fstab by using the command sudo chown Alice /etc/fstab and run the check again. Why is the directory /etc listed under changed files? What is the difference between atime, mtime and ctime?

The output is for changes in the entire directory. 

\begin{itemize}
    \item atime: time the file was last accessed
    \item mtime: time when the file was modified for the last time, i.e. its content modified.
    \item ctime: time when metadata of the file was changed, like the ownership.
\end{itemize}


\paragraph{Problem 5.17}
Configure AIDE on Alice such that the system binaries as well as /etc and other relevant files are checked. Determine yourself what “relevant” means in this context. Use the given AIDE configuration file and add your selection lines.

\begin{lstlisting}
/
/etc
/bin
!/tmp
!/home #maybe more detailed
!/dev
...
\end{lstlisting}

\paragraph{Question 5.1}
What are rootkits and what is their purpose? Explain the benefits that they provide to an adversary.

Rootkits are a set of programs which enable the adversary to hide its traces and installed programs, e.g. by modifying logs or essential programs like ls to not show some files.

\paragraph{Question 5.2}
Rootkits are typically mentioned in combination with an adversary
who has gained administrative rights on a target machine. Why is this case especially
critical, compared to the case where an adversary has not yet gained these rights?

Once the adversary has gained root rights, everything is open to him, enabling the rootkit to tamper with logs, system files etc in order to hide from detection. Non-root users can't edit these files.

\paragraph{Question 5.3}
How can rootkits be detected and what are possible counter-measures?

Using a tool like Advanced Intrusion Detection Environment (AIDE) in order to check for the integrity of directories and files against a previously created database. "{}[\dots] these tools work with different algorithms in order to minimize the probability that a specific file is replaced by another file with precisely the same checksum."{}

\paragraph{Question 5.4}
One of the servers under your control behaves strangely and you suspect that a hacker has gained administrative rights on it. Fortunately, you have an external backup of the system. So you decide to compare the MD5 checksums of system-relevant files. How would you proceed? What must you take into account?

Calculate the MD5 checksum of every file, preferably on a trusted system (not this server), and compare it with the checksum of backuped version of the file. Furthermore you need to assume that the backup might contain compromised files as well then one needs to compare against other versions of the files, on the other hand some system files could have been changed by a intended update leading to false positives on the check.

\paragraph{Question 5.5}
Explain the purpose of an intrusion detection system and the difference between host-based and network-based intrusion detection systems.

Intrusion detection systems (IDS) try to detect whether a system has been tampered with, for example by a hacker who gained admin rights. Network based: IDS analyzes the incoming network traffic in detail, perhaps even deep package inspection. Tries to assure that only traffic which is to be expected by the respective service is actually sent. Host-based: Monitors changes to important system-files.

\paragraph{Question 5.6}
What is an intrusion prevention system? What are the differences with respect to intrusion detection systems? Would you consider a firewall (packet-filter) as an intrusion prevention system or as an intrusion detection system?

Intrusion prevention Systems actively try to hinder an adversary to enter a system or make severe changes. For example by "{}filtering"{} certain commands and including further authentication checks. While intrusion detection systems try to detect whether a system has been tampered with, usually by comparing it to a previous state.

With a set of clever rules the firewall tries to minimize the attack surface for a given system. Thus I see it as an intrusion prevention system. Analyzing the sent packages in greater detail (using some stateful program) would probably also help to detect a compromised system.

\section*{Chapter 6}
\paragraph{Problem 6.1}
vulnerability description in OWASP’s terminology involves five components: threat agents, attack vectors, a security weakness, a technical impact and a business impact. What is a threat agent? What is meant by an attack vector?

\begin{itemize}
    \item Threat agent: WHO is able to conduct the attack
    \item Attack Vector: which way of attacking (vulnerability) is exploited
\end{itemize}

\paragraph{Problem 6.2}
At the time of writing this book, cross-site scripting (XSS) and cross-site request forgery (CSRF) were extremely popular attacks. Explain how both attacks work.

\begin{itemize}
    \item XSS: execute injected code on a website, e.g. through a form which doesn't escape script tags
    \item CSRF: Execute some request which the user doesn't intend to do via the browser.
\end{itemize}

\paragraph{Problem 6.3}
Gather information about the infrastructure (web server, etc.) running on bob using tools such as Nmap, Netcat and Burp Suite on host mallet.

\verb+sudo nmap -A -O bob+
On port 80 and 443 run Apache httpd 2.4.25 ((Debian)), furthermore there is ssh running. All on Debian 10+deb9u4. Website is delivered via Flask 0.12.2, see returned html.

\paragraph{Problem 6.4}
List the strings you would look for in an application and argue why they are interesting. For example, input tags in form fields might be an input field for a password.

\begin{itemize}
    \item \verb+<input...+
    \item \verb+<script...+
    \item \verb+hidden+
\end{itemize}

\paragraph{Problem 6.5}
Try to discover relationships between the different pages on host bob’s web site. What gets called when and by whom? Which pages accept user-supplied input? What methods are used (GET vs. POST)? What are the directory and file names? Which pages require prior authentication and which do not? 

Combine online and offline resources to answer these questions. This requires studying the application using the browser and proxy (Burp Suite) as well as studying a local copy of the application. Gather all the information about the application in a suitable way. It is up to you how you structure the information, e.g., in a table, flowchart, mind map or finite state machine.

[Skipped question]

\paragraph{Problem 6.6}
Host bob runs a web server that hosts Bob’s web shop. The input of some of the site’s web forms is used in SQL queries. Find these forms and test them for vulnerabilities. What tools did you use, and how did you use them?

Try out every form I could find with some SQL injection: \verb+1' or TRUE -- +. Login form and simple search worked both. Thanks to \href{https://securitytutorials.co.uk/sql-injection-basics/}{securitytutorials.co.uk} for the double dash trick.

Furthermore active sessions can just be selected by changing the \verb+session_id+ in the url-params.
\paragraph{Problem 6.7}
Given the SQL injection vulnerability you have found in Problem 6.6, what is a possible structure of the SQL statement that uses the unvalidated input?

\verb+SELECT * FROM goods_db_simple WHERE <name> like ´$query%´+
Then insert something like: \verb+query = a´ OR TRUE -- +

\paragraph{Problem 6.8}
Using the vulnerability that you have previously identified, first come up with a SQL injection that returns a list of all tables and their columns present in the database. Then identify and extract the table containing the user names and password hashes.

Somehow \verb+union+ the result from the search with the password list.
\begin{lstlisting}
http://bob/goods_db_simple?session_id=0&query=a'UNION SELECT 0, table_name, column_name, 0, 0, 0 FROM  information_schema.columns -- &submit=Search
\end{lstlisting} 
The zeros just pad out some colums in the table, this was found by trial and error. 
\begin{figure}[h!]
    \centering
    \includegraphics[width=\textwidth]{images/SQL_IN_Tables.png}
\end{figure}
Now apply the same procedure to the interesting table named user.

\begin{lstlisting}
http://bob/goods_db_simple?session_id=0&query=a'UNION SELECT 0, login,  password_hash, 0, 0, 0 FROM  user -- &submit=Search
\end{lstlisting} 


\paragraph{Problem 6.9}
The password cracker John the Ripper (command john) is installed on mallet. Use it to recover the original passwords from the password hashes you extracted from the database in the last assignment. Make sure you are running john it in the directory where it resides or using the full path name.

Using the solutions: mallet123, bob123, Alice123.

\paragraph{Problem 6.10}
Name two different ways to avoid SQL injections and give short explanations of each of them.

Escape all non alphanumerical characters beforehand. User e.g. SQLAlchemy, do not use plain SQL anywhere.

\paragraph{Problem 6.11}
The vulnerable piece of code of Bob’s web shop can be found in the file /var/www/flask/www/db\_funcs.py on bob. It contains two implementations: one insecure (it corresponds to the RAW\_SQL configuration) and one that uses the Python framework SQLAlchemy [7] to handle SQL queries (it corresponds to the SQL\_ALCHEMY\_ORM configuration). Use prepared statements to fix the insecure implementation of the select\_like() function. Check that you fixes indeed remove the vulnerability.

Better solution: use SQLAlchemy to execute the statement, for the prepared statement (which is only half supported by SQLAlchemy) see solutions...

\begin{lstlisting}
table.query.filter(table.field_name.like(field_value)).all()
\end{lstlisting}

Will need some adjustment in ordet to use \verb+field_name+ correctly.

\paragraph{Problem 6.12}
Investigate all pages of Bob’s shop and try to find out if any of them might be related to code, which processes XML. Where would you start to search and what tools would you use?

Use things that might be rendered, in this case the post feature. Create a post like this \verb+ <a href="https://www.w3schools.com">Visit W3Schools</a> + it is rendered as html. Thus we might be able to abuse it even more, XSS, etc. 

Looking at the solution there is even a better option (the /search\_endpoint, found from complex search)

\paragraph{Problem 6.13}
After identifying the input which possibly reaches an XML parser, check whether the processing code is vulnerable to an XXE attack and, if so, exploit it to read some of the server’s files.

Via Burbsuite edit the xml parameter in the /search\_endpoint.

\paragraph{Problem 6.14}
Check whether any elements of Bob’s shop read files and present them to the user.

E.g. \verb+http://bob/images/?session_id=0&path=nice_saw.jpg+ looks vulnerable.

\paragraph{Problem 6.15}
Check if your findings can be exploited to mount a path traversal attack.

\begin{lstlisting}
check: 
http://bob/images/?session_id=0&path=../../../../etc/passwd

This Message helps
The file /var/www/flask/www/static/images/../../../../etc/passwd does not exist!

http://bob/images/?session_id=0&path=../../../../../../../../../etc/passwd
\end{lstlisting}

\paragraph{Problem 6.16}
Find out which page of Bob’s shop is vulnerable to SSTI.

Entering a simple template thing in every field and look what comes out. Something like: \verb+{{3**3}}+, if we see a 27 then it worked. This works for sure in the forum page.

\paragraph{Problem 6.17}
In Problem 6.16 we identified that the forum page is vulnerable to SSTI. Besides, we already know that the rendering engine is Jinja2. One of the key ingredients we need for our final exploit is Jinja’s control statements. Exploit the forum page to make it render a message that contains all odd numbers between 0 and 100. Hint: Use Jinja’s for and if control statements, and Python’s range() function.

\begin{lstlisting}
{% for i in range(100) %}
{% if i % 2 %}
{{ i }}
{% endif %}
{% endfor %}
\end{lstlisting}

\todo{not running jinja exploit}

\paragraph{Problem 6.18}
\todo{todo}
\paragraph{Problem 6.19}
\todo{todo}
\paragraph{Problem 6.20}
\todo{todo}
\paragraph{Problem 6.21} 
On host bob, look at the function forum() in the Python module /var/www/flask/www/routes.py, find the code that is vulnerable to SSTI, and fix it.


Use Jinja all the way through. This means that you should add all posts using the Jinja specific for loop construct instead of adding it to the html string and then passing it to the jinja engine. To summarize: 

assuming \verb+posts+ is an array of post dicts:

\begin{lstlisting}
posts = retrive_posts()

templ = """...
{% for p in posts %}
<th scope='row'> {{ p.date }} </th>
<td> {{ p.login }} </td>
<td> {{ p.text }} </td>
{% endfor %}
...
"""

flask.render_template_string(html, form=form, posts=posts)
\end{lstlisting}


\paragraph{Problem 6.22}
In the previous problem we studied a way to obtain a shell on the remote system. What is the user ID of this shell? If the user ID was not 0, would it be possible to simply download the /etc/shadow file, use the password cracker John the Ripper to extract the passwords, and to log in to bob as root?

We receive a shell with the user associated with apache2 which is www-data. This user is not able to retrieve the file /etc/shadow via the approach in Problem 6.15. 

\paragraph{Problem 6.23}
Describe how the exploit works. How are different vulnerabilities combined to acquire remote root access on bob? Find information about the kernel exploit on the Internet and describe the vulnerability in the kernel code.

First it uses the same approach as in Problem 6.20, then it uploads a kernel patch using the exploit CVE-2017-0358 (as described in the comments of the code). 

\paragraph{Problem 6.24}
Why is session management important in combination with HTTP?

HTTP per-se is a stateless protocol. Thus we need to send some authentication (cookie or similar) with all requests. 

\paragraph{Problem 6.25}
The transport-layer protocol TCP is connection oriented and TCP connections are sometimes called sessions. How is a TCP session defined, and how do the endpoints identify a TCP session?

After the initial handshake the session is established to another IP address plus the port, and is then terminated using a handshake again.

\paragraph{Problem 6.26}
Log in using one of the user names given above. What is transmitted? How does the authentication process work? List potential security problems.

Password and username are sent unencrypted which can simply be intersected and which is stored in the browser history.

\paragraph{Problem 6.27}
Given your observations, how do you think that session management is implemented? Do you see any potential security problems?

As already mentioned in Problem 6.6, the Server responds with the corresponding session\_id. Problem let's assume that mallet is logged in with session\_id 1 and bob with id 2. Mallet can simply change to session 2, as long as this database entry exists, i.e. as long as bob did not log out.

Session handling is probably done by simply checking the session\_id.

\paragraph{Problem 6.28}
How does the server signal to the client that access to the resource requires authentication?

Sends an error 401.

\paragraph{Problem 6.29}
What happens if after successful log in to the protected area of the web site, you later want to reconnect to the protected area?

After login, sends the password via header in Authoization: \verb+Basic bWFsbGV0Om1hbGxldDEyMw==+ where  \verb+bWFsbGV0Om1hbGxldDEyMw==+ decodes to \verb+mallet:mallet123+ in base64.

\paragraph{Problem 6.30}
Use mallet to connect to Bob’s shop. Log in to the web shop and study the authentication process. How are the user name and password transmitted this time? After a successful login, you get a cookie. What might the name attribute of the cookie stand for? Hint: Log in multiple times and study the differences.

Sends it via POST this time. Stores the session\_id in the cookie. 

\paragraph{Problem 6.31}
How can you protect Bob’s web shop from XSS attacks like the one we have demonstrated above? Hint: Messages received as GET parameters in HTTP requests are inserted into the forum by the code in the function forum() of the module /var/www/flask/www/routes.py.

Correctly escape scripttags, or even better all non-alphanumerical chars.

\paragraph{Problem 6.32}
Identify pages of Bob’s shop that may be vulnerable to a reflected XSS attack. To do so, check which pages reflect user input.

Message User displays the message to be sent. 

\paragraph{Problem 6.33}
Exploit the vulnerable component identified in Problem 6.32 by
making Alice’s browser execute arbitrary code (similarly to the exercise in
Sect. 6.6.2).

Create a link similar to:

\begin{lstlisting}
http://bob/message_user?user=%3Cscript%3Ealert%28%22Hello%21%20I%20am%20an%20alert%20box%21%21%22%29%3B%3C%2Fscript%3E&message=message&submit=Send
\end{lstlisting}

Link encodes \verb+<script>alert("Hello! I am an alert box!!");</script>+. 

\paragraph{Problem 6.34}
How can you protect Bob’s web shop from Reflected XSS? Hint: Messages received as GET parameters in HTTP requests are inserted into the message\_user page by the code in the function message\_user() of the module /var/www/flask/www/routes.py.

Same as in Problem 6.31: Correctly escape scripttags, or even better all non-alphanumerical chars.

\paragraph{Problem 6.35} 
Identify pages of Bob’s shop that may be vulnerable to DOM-based XSS. To do so, check which pages use JavaScript to generate new content on the client side.

Simple Search, the searched term is not forwarded via the server. But inserted client-side with \verb+document.write(...)+

\paragraph{Problem 6.36}
Exploit the vulnerable component identified in Problem 6.35 by making Alice’s browser execute arbitrary code (similarly to the exercise in 6.6.2).

create a link similar to this:
\begin{lstlisting}
http://bob/goods_db_simple?query=%3Cscript%3Ealert%28%22Hello%21%20I%20am%20an%20alert%20box%21%21%22%29%3B%3C%2Fscript%3E&session_id=1&submit=Search
\end{lstlisting}

Link encodes \verb+<script>alert("Hello! I am an alert box!!");</script>+. 

\paragraph{Problem 6.37}
How can you protect Bob’s web shop from DOM-based XSS?

Needs to be correctly escaped/sanitized on clien-side JS-code.

\paragraph{Problem 6.38}
Find a page in Bob’s shop that is vulnerable to CSRF attacks. Good candidates are pages containing input forms that, when submitted, cause state changes in the web application.

Forum and Message look both like valid options however the message board and its functions is not fully clear.

\paragraph{Problem 6.39}
Exploit the vulnerable page by crafting a malicious web page that contains a link to the vulnerable page and hosting it on mallet’s web server. Then imitate the victim by first logging into Bob’s shop as a legitimate user (e.g., as Alice) and then visit the malicious page to trigger the CSRF attack and perform an unintended action on the victim’s behalf.

\begin{lstlisting}
bob/forum?message=no%20one%20cares%0A&submit=Post
\end{lstlisting}

\paragraph{Problem 6.40}
Browse the web to find two mechanisms to defend against CSRF and explain them.

Confirm explicitly via form, Token to prevent accidental sending, e.g. Synchronizer token pattern.

\paragraph{Problem 6.41}
Use Mallet’s web browser to connect to Bob’s web shop using the URL https://bob. When doing this for the first time using the HTTPS protocol, you get a warning. For example, Firefox says: “Secure Connection Failed”. 1. Explain the problem on a conceptual level. 2. Why does this problem not show up if you connect for the first time, for example, to https://www.nsa.gov?

It uses a certificate, which in this case is self-signed by bob. Taking a look at the Certificat of https://www.nsa.gov, this one is issued by a trusted certificate authority.

\paragraph{Problem 6.42}
On mallet, use a sniffer (Wireshark or tcpdump) to observe the set-up phase of a secure connection. Looking at the sniffer’s output, describe how the secure connection is set up in terms of exchanged messages.

Handshake, Client-, Server-Hello, Agree to a key, encrypted data ...

\paragraph{Problem 6.43}
We assume in the following that Alice exclusively uses HTTPS to connect to Bob’s web shop. 1. In Sect. 6.5.2 we used HTTP Basic Authentication to authenticate web shop users. Assume that Alice logs in to the web shop. Is it still possible to sniff her user credentials? 2. In terms of session management, we have seen the problem of predictable session identifiers. The problem with this kind of session identifier is that it is both sent in plaintext and is guessable. Are both problems now solved? 3. Finally, consider the XSS attack you have performed in Sect. 6.6.2. Would a simple change to HTTPS, without additional measures, prevent this type of attack?

\begin{enumerate}
    \item No, they are now sent via the payload of the request, which is sent via SSL.
    \item Session id is not visible but technically still guessable.
    \item No, the data is not magically escaped but only transmitted encrypted
\end{enumerate}

\paragraph{Question 6.1}
Session tokens play a crucial role in web applications. Explain why this is the case and state the possible implications for the security of web applications.

The session token contains information about the current session of meaning. The server can determine which user is logged in, derive its permissions, etc. These Tokens are randomly generated server-side and stored on the client and sent to the server for authentication for other requests. If the adversary can predict or retrieve said tokens, it can impersonate other users.

\paragraph{Question 6.2}
Explain two ways in which an adversary could get hold of a user’s session token. For both possibilities, provide an appropriate corresponding countermeasure.

\begin{enumerate}
    \item Using XSS, send the session token from the client to the adversary. $\rightarrow$ prevent XSS by sanitizing all user inputs. 
    \item Connection is not encrypted or the session\_id is sent via the GET parameter in an encrypted connection. Enforce HTTPS for all important services and set the respective values in the cookies. 
\end{enumerate}


\paragraph{Question 6.3} Explain SQL injections. Why and under what circumstances do they work?

If the user-input is not correctly sanitized an input directly into an SQL statement, the user might be able to forge the input in such a way that he interacts directly with the database. Thus he might be able to retrieve information which he should not see or even tamper with the login logic, to login without a password. Example Query:

\verb+SELECT * FROM users WHERE name like ´$query%´+
Then insert something like: \verb+query = a´ OR TRUE -- +

\paragraph{Question 6.4}
Explain how SQL injections can be prevented.

\begin{itemize}
    \item Use e.g. SQLAlchemy to create the respective operations.
    \item Escape all used strings received from the user.
    \item Use Prepared Statements
\end{itemize}

\paragraph{Question 6.5}
Consider a simple message board on the Internet, where users can post messages to be read by other users using their browser. 1. Give a simple example of how the message board could be used by an adversary to mount a cross-site scripting attack. Describe the attack schematically, i.e., without code. 2. What could be done on the web server to prevent cross-site scripting attacks? 3. What could be done on the client side to prevent this type of attacks?

\begin{enumerate}
    \item If the board doesn't sanitize the input correctly, it is possible to insert messages with the \verb+<script>+-tag. Instead of rendering the text, the scrip inside the tag will be executed.
    \item Correctly escape all non-alphanumerical characters, restrict the set of rendered inputs, e.g. restrict to markdown only.
    \item Unpractical: install no-script plugin or "{}XSS Auditor"{}. Otherwise, not much to be done.
\end{enumerate}

\paragraph{Question 6.6}
Typically, input validation is mentioned as a protection against buffer-overflows and SQL injections. Explain how input validation can prevent the above-mentioned attacks.

\begin{itemize}
    \item buffer-overflow: Before moving the data anywhere check the length off the sent data and abort if too long.
    \item SQL injections: Checking whether the user input only contains the expected characters (alphanumerical) or if that is not possible, save the characters correctly escaped.
\end{itemize}

\paragraph{Question 6.7}
When using certificate-based authentication, such as in SSL/TLS or SSH, how can the server check that the user really possesses a valid private key without sending the key to the server?

Send a random string to the client, encrypted with the public key. Only the user with the correct private key will be able to respond with the corresponding plaintext.

\paragraph{Question 6.8} The following is an example of a cross-site request forgery (CSRF) attack. What is the actual goal of the adversary? What does he gain with this attack? 2. Name at least two ways to prevent such an attack. Note that the attack uses several independent components and a combination of weaknesses. Identify countermeasures for some of them.

\begin{enumerate}
    \item Being able to change DNS entries is really interesting for the adversary, for example he could employ a DNS-rebinding-attack, just send certain requests to an adversary-owned server, or proxy the data via an own server in order to analyze the traffik.
    \item Use HTTPs and certificates in order to verify the server. Prevent access to the router: change password, change port of interface, configure firewall to only access the router when especially enabled.
\end{enumerate}


\section*{Chapter 7}
\paragraph{Problem 7.1}
Briefly explain the components of an asymmetric encryption scheme and the required properties.

We need an algorithm with some asymmetric properties: meaning we need one key to encrypt the data (public key) and one to decrypt the data (private key). The public key is - as the name mentions - publicly known. Ideally the algorithm works in the other way around as well: encrypt with the private key, decrypt with the public key. Furthermore an efficient key-generator is needed. 

\paragraph{Problem 7.2}
In the scenario in Example 7.2, Alice sends her public key over an insecure communication channel to Bob. There is the possibility for an adversary to mount a man-in-the-middle attack. 1. Describe schematically how such a man-in-the-middle attack works. What messages are exchanged between Alice, Bob, and the adversary. 2. How could this kind of attack be prevented? What must Alice and Bob be aware of if they want to use public key cryptography as described in the scenario?

\begin{enumerate}
    \item Mallet sits inbetween Bob and Alice: Bob requests key from Alice via Mallet, Mallet requests key from Alice, sends his own key to Bob. Bob encrypts with Mallet's key sends packet to Mallet, Mallet decrypts with his key, encrypts with Alice's key and sends the data to Alice. Response from Alice is sent in the reverse direction through Mallet's hands. 
    \item Keys need to be shared via secure channels or for example via the Diffie–Hellman key exchange.
\end{enumerate}

\paragraph{Problem 7.3}
How can public key cryptography be used by two honest agents, say Alice and Bob, to create a shared secret in the presence of an adversary, if Alice and Bob did not share a secret beforehand?

As already mentioned via e.g. Diffie–Hellman key exchange, which depends on the used Encryption Algorithm.

\paragraph{Problem 7.4}
Suppose Alice publishes her public key on her web page. How can Bob determine its authenticity?

Almost impossible to do that directly. Either have a third party (CA) to verify Alice's Key, establish a web of trust, key-signing-parties...

\paragraph{Problem 7.5}
Consider the case where you connect from your computer to your bank’s web site, for example, to use online banking services. Typically, the bank’s login page is secured using HTTPS, which uses certificate-based authentication. In view of what has been said in this chapter so far, it is clear that your client must have received the bank’s certificate authentically beforehand. How is this done? 2. Assume that you have successfully established an HTTPS session to your bank’s web site. What are the resulting security guarantees for both endpoints of the session, i.e., you and your bank?

\begin{enumerate}
    \item There is some CAs which have self signed (root-) certificates which are installed and trusted by the browser. There is a set of certificates which are signed by the CA and used by it in order to sign the certificates of e.g. the Bank (operative CA Certificate). The bank's certificate is signed by the with the operative CA Certificate by the CA. The browser then checks in the reverse direction: verify the bank's cert with the verification key of the operative CA Certificate, which is tested with the verification key of the root CA Certificate which is installed in the browser.
    \item Encrypted channel, authenticity of the bank - given the root CAs are trustworthy. However, the authenticity of the user is not guaranteed  to the bank $\rightarrow$ two Factor Authentication.
\end{enumerate}


\paragraph{Problem 7.6}
Self-signed certificates may at first seem a bit odd and merely a work-around in cases where you do not want to pay for a certificate issued by an “official” certificate authority. In particular, self-signed certificates do not seem to provide any kind of security guarantee. Why does it still make sense to allow self-signed certificates, even if you would only accept certificates signed by “official” certificate authorities?

The root certs from Problem 7.5 are also self-signed. Furthermore one could argue that with a self-signed at least the connection is encrypted without guarantee for the authentic host, which is better than nothing. 

\paragraph{Problem 7.7}
Create a new key pair and use the CA to sign the public key. Explain the commands you use.

First generate a key to sign: e.g. like this.
\verb+openssl genrsa -out to_be_signed.key+

Generate the CSR thanks to \href{https://www.switch.ch/pki/manage/request/csr-openssl/}{switch.ch}: 
\verb+openssl req -new -key to_be_signed.key -out to_be_signed.csr+

Create the Certificate (as done in point 7 of the example):
\verb+sudo openssl ca -in to_be_signed.csr -config /etc/ssl/openssl.cnf+

\paragraph{Problem 7.8}
Suppose Alice loses her signing key. For example, it was stored on a token, which breaks. To what extent is this problem? Should she revoke the associated public key certificate?

If she only loses the key, but nobody else gets hold of it. It is not too dramatic, she simply cannot sign any documents anymore. It is not not really needed to revoke the key.


\paragraph{Problem 7.9}
1. Key revocation plays an important role in the context of public key cryptography. Why is this not the case for symmetric keys? 2. How can you use asymmetric cryptography for communication so that even if your private key is ever compromised, all communication prior to the compromise still remains secret? (This property is called perfect forward secrecy.)

\begin{enumerate}
    \item Usually Symmetric keys are used only a few times and renegotiated between the involved subjects (usually via asymmetric procedures).
    \item Again use a key-exchange-scheme like Diffie-Hellman (see Problem 7.2)
\end{enumerate}

\paragraph{Question 7.1}
Briefly characterize the following building blocks of a public key infrastructure (PKI): public key, private key and certificate.

\begin{itemize}
    \item public key: key used by the client to encrypt data to send to the server.
    \item private key: key used by the server to decrypt the sent messages
    \item certificate: signature of the public key. This is generated by the CA in order to guarantee for the authenticity of the public key, and the agent behind it.
\end{itemize}

\paragraph{Question 7.2}
A self-signed certificate is a certificate that was signed with the private key that corresponds to the certificate’s public key. Do self-signed certificates make sense? Explain your answer.

The root CA certificates are all self-signed and need to be enabled in the browser. In our chain of trust, there needs to be a "{}starting point"{} which always has to be a selfsigned cert since there is no higher authority.

\paragraph{Question 7.3}
1. Suppose you have a public key and the associated certificate issued by a certificate authority (CA). What kind of guarantees should the certificate provide for you? How do you obtain the guarantee that the certificate really was issued by the respective CA? 2. Suppose that Alice wants to authenticate Bob using certificate-based authentication. Suppose further that Alice holds the CA’s certificate and that Bob has a certificate for his public key issued by the CA. Explain the necessary steps of the authentication process.

\begin{enumerate}
    \item The CA guarantees for the authenticity of the public key. Meaning if we trust the CA then we can trust the owner of the public key. If we have another (possibly self-signed) certificate guaranteeing for the authenticity of the CA. Those self-signed Certificates (root CA certs.) have to be installed directly in the browser.
    \item Bob contains a signature issued by the CA. Using the public key int the CA certificate, Alice verifies that signature. If the Signature stems from the CA, Alice can trust bobs public key.
\end{enumerate}

\paragraph{Question 7.4}
Suppose you are a new administrator of a small company which recently introduced a simple PKI to ensure secure e-mail communication for its employees. As a first step you analyze the IT infrastructure. 1. You recognize that the CA of the PKI synchronizes its clock daily with an unauthenticated time server. What security problems could arise from this? How could the problems be detected? What are possible countermeasures? 2. What possible security problems arise if an adversary manages to alter the clock used by the legitimate clients? What are appropriate countermeasures in this case? 

\begin{enumerate}
    \item Potentially intervene and impersonate as the time server. Detection compare against multiple clocks, check against internal clock. Solution: only allow small automatic adjustments (no leap over several days), request confirmations from admin. Use an authenticated time server.
    \item Since certificates have an expiration date, the adversary might tamper with this, at least producing a denial of service.
\end{enumerate}

\todo{ask}

\paragraph{Question 7.5}
1. Describe the guarantees that each of the involved parties (client and server) have after the execution of the protocol. For each of the guarantees argue (informally) why it should hold, i.e., what are the necessary prerequisites for the protocol to achieve the corresponding guarantee. 2. Give an example of an application scenario in which it makes sense to use this form of TLS handshake.3. Assume that you want to connect to a web site using the TLS handshake as it is depicted in Fig. 7.3. When connecting to the web site, your browser interrupts the connection and shows a “Web Site Certified by an Unknown Authority” warning (in the case of Firefox). At which step of the protocol (in Fig. 7.3) does the problem originate? Could an adversary make use of this problem? If your answer is “Yes”, explain how, and if your answer is “No”, explain why.

\begin{enumerate}
    \item Given the CA has not been compromised, this protocol guarantees the authenticity of the server to the client. If the key-generation works flawlessly, the adversary has no chance to predict the MS thus a secure communication is guaranteed.
    \item Secure communication over HTTPS e.g. for Webbrowsers logged-in sessions where the communication needs to be secure. \shrug
    \item This happens when checking the validity of the certificate. Firefox and other browsers let you add the unvalidated certificate, resp. lets you add an exception. If these exceptions are added by a random user, the adversary can read our traffic and forward it to the server. I.e. the issue is now similar to a compromised CA, resulting in a man in the middle attack.
\end{enumerate}

\paragraph{Question 7.6}
1. What is the main difference in terms of security guarantees with respect to the previous version presented in Fig. 7.3? 2. Find a security problem in the way the server handles requests; describe informally how a potential adversary could use this weakness. 3. Propose a fix to the problem you found in 2. 

\begin{enumerate}
    \item
    \item\todo{todo}
    \item 
\end{enumerate}


\section*{Chapter 8}
\paragraph{Problem 8.1}
Explain in your own words the terms risk analysis and risk management in the context of information security. What is the relationship between them?

Risk analysis tries to assess and evaluate the risk by analyzing the system, finding potential vulnerabilities and their impact. Based on this analysis the risk management decides on the countermeasures, adjusting the system. 

\paragraph{Problem 8.2}
Give an example of an information system where two stakeholders have diametrically opposed interests.

Security Responsible vs HR: Security wants to spend more money on Security Experts, HR needs to adhere to a budget and doesn't want to hire another employee.

\paragraph{Problem 8.3}
Give an example of a system asset that has a state space that can be measured numerically.

Supercomputer with shared resources among different tasks. Every task has a runtime, needed resources and priority. Cost-function decides on how many resources and for how long to provide to each task, resp. on how to schedule these tasks.

\paragraph{Problem 8.4}
You can find databases of known vulnerabilities for many kinds of software on the Internet (see, for example, www.securityfocus.com). However, the systems you analyze will hopefully not contain known vulnerabilities. Given what has been said so far, do you see any way of coping with unknown vulnerabilities? Illustrate your answer with an example.

On cannot directly prevent unknown vulnerabilities. Preventive measures can , however, be taken as for example change passwords, certificates and keys on a regular basis.

\paragraph{Problem 8.5}
It is common when analyzing or planning security measures to start by identifying potential adversaries. For example, if you secure your home against burglars you will probably not consider governmental agencies or the police as potential adversaries. Similarly for information systems, one usually need not consider governmental agencies as a potential threat source. Give two industry examples where governmental agencies should be considered as a potential threat source, and explain why this is the case.

\begin{itemize}
    \item Secure messaging services like Threema: They provide encrypted communication between two (potential terrorist) parties or adversaries of the governemnt, and the agency would want to intecept the communicaton.
    \item Military Systems: Contains potentially valuable information.
\end{itemize}


\end{document}

